# 1 "full_duplex_serial_vl.c"
# 1 "<built-in>"
# 1 "<command-line>"
# 1 "full_duplex_serial_vl.c"
# 19 "full_duplex_serial_vl.c"
# 1 "full_duplex_serial_vl.h" 1





struct fds_mailbox
{
        unsigned int stack[10];
        unsigned int txPin;
        unsigned int rxPin;
        unsigned int baudRate;
 char rxBuffer[16];
 char txBuffer[16];
 int rxHead;
 int rxTail;
 int txHead;
 int txTail;
};
# 20 "full_duplex_serial_vl.c" 2


# 1 "../libpropeller/../include/cog.h" 1
# 17 "../libpropeller/../include/cog.h"
extern __attribute__((cogmem)) volatile unsigned int _PAR __asm__("PAR");
extern __attribute__((cogmem)) volatile unsigned int _CNT __asm__("CNT");
extern __attribute__((cogmem)) volatile unsigned int _INA __asm__("INA");
extern __attribute__((cogmem)) volatile unsigned int _INB __asm__("INB");
extern __attribute__((cogmem)) volatile unsigned int _OUTA __asm__("OUTA");
extern __attribute__((cogmem)) volatile unsigned int _OUTB __asm__("OUTB");
extern __attribute__((cogmem)) volatile unsigned int _DIRA __asm__("DIRA");
extern __attribute__((cogmem)) volatile unsigned int _DIRB __asm__("DIRB");
extern __attribute__((cogmem)) volatile unsigned int _CTRA __asm__("CTRA");
extern __attribute__((cogmem)) volatile unsigned int _CTRB __asm__("CTRB");
extern __attribute__((cogmem)) volatile unsigned int _FRQA __asm__("FRQA");
extern __attribute__((cogmem)) volatile unsigned int _FRQB __asm__("FRQB");
extern __attribute__((cogmem)) volatile unsigned int _PHSA __asm__("PHSA");
extern __attribute__((cogmem)) volatile unsigned int _PHSB __asm__("PHSB");
extern __attribute__((cogmem)) volatile unsigned int _VCFG __asm__("VCFG");
extern __attribute__((cogmem)) volatile unsigned int _VSCL __asm__("VSCL");


extern unsigned int _clkfreq;
# 23 "full_duplex_serial_vl.c" 2


static __attribute__((cogmem)) volatile struct fds_mailbox* pm;


static __attribute__((cogmem)) int txPin;
static __attribute__((cogmem)) int rxPin;
static __attribute__((cogmem)) int bitcycles;
static __attribute__((cogmem)) int halfBitcycles;


static __attribute__((cogmem)) int txWaitCycles;
static __attribute__((cogmem)) int txShiftReg;
static __attribute__((cogmem)) int txBitCnt;


static __attribute__((cogmem)) int rxWaitCycles;
static __attribute__((cogmem)) int rxShiftReg;
static __attribute__((cogmem)) int rxBitCnt;
static __attribute__((cogmem)) int bit;
static __attribute__((cogmem)) int temp;


static __attribute__((cogmem)) volatile void* pTxThread;
static __attribute__((cogmem)) volatile void* pRxThread;
# 87 "full_duplex_serial_vl.c"
__attribute__((native)) void main (volatile struct fds_mailbox *m)
{

    pm = m;


    rxPin = pm->rxPin;
    txPin = pm->txPin;
    bitcycles = 80000000 / pm->baudRate;
    halfBitcycles = bitcycles / 2;
    _OUTA = (unsigned)1 << txPin;
    _DIRA = (unsigned)1 << txPin;


    pRxThread = &&rxThread;
    pTxThread = &&txThread;


    txThread :
    {

        while(1)
        {

            do { pTxThread = && next_1; goto *pRxThread; next_1 :; } while (!(pm->txHead != pm->txTail));;


            txShiftReg = pm->txBuffer[(pm->txTail)++ & (16 - 1)];


            _OUTA = 0;


            txWaitCycles = (int)_CNT + bitcycles;

            for (txBitCnt = 0; txBitCnt < 8; txBitCnt++)
            {
                do { pTxThread = && next_2; goto *pRxThread; next_2 :; } while (!(((int)_CNT - txWaitCycles >= 0)));;
                _OUTA = (txShiftReg & 1) << txPin;
                txWaitCycles += bitcycles;
                txShiftReg >>= 1;
                (line, thisThread, thatThread) thisThread = && next_line; goto *thatThread; next_line :; (22, pTxThread, pRxThread);
            }

            do { pTxThread = && next_3; goto *pRxThread; next_3 :; } while (!(((int)_CNT - txWaitCycles >= 0)));;
            _OUTA = 1 << txPin;


            txWaitCycles += bitcycles;
            do { pTxThread = && next_4; goto *pRxThread; next_4 :; } while (!(((int)_CNT - txWaitCycles >= 0)));;
        }
    }


    rxThread :
    {

        while(1)
        {
            rxShiftReg = 0;

            do { pRxThread = && next_5; goto *pTxThread; next_5 :; } while (!(((_INA >> rxPin) & 1) == 0));;


            rxWaitCycles = (int)_CNT + halfBitcycles;
            do { pRxThread = && next_6; goto *pTxThread; next_6 :; } while (!(((int)_CNT - rxWaitCycles - 100 >= 0)));;

            rxWaitCycles = (int)_CNT + bitcycles;

            for (rxBitCnt = 0; rxBitCnt <= 7; rxBitCnt++)
            {
                do { pRxThread = && next_7; goto *pTxThread; next_7 :; } while (!(((int)_CNT - rxWaitCycles-100 >= 0)));;
                bit = (_INA >> rxPin) & 1;
                rxWaitCycles = (int)_CNT + bitcycles;
                rxShiftReg |= bit << rxBitCnt;
            }


            if ((pm->rxHead - pm->rxTail) < 16 - 1)
            {

                pm->rxBuffer[pm->rxHead++ & (16 - 1)] = (char)rxShiftReg;
            }


            do { pRxThread = && next_8; goto *pTxThread; next_8 :; } while (!(((int)_CNT - rxWaitCycles-100 >= 0)));;
        }
    }
}
